# rspec/airborne/spaceborne based API tests

## Setup
If you have rvm set up reasonably on your system, the .ruby-XXX files in the apitest directory should create the rvm gemset for you. You will then need to:

```ruby
gem install bundler
bundle install
```

## Environment
| Environment Variable | values | default |
|:------ |:----- |:----- |
| TEST_ENV | dev, local, qa, staging, prod | dev |
| NAMESPACE | as in other test environments | |                    
| API_KEY   | api key for redshirt account | |
| REDSHIRT_PW | the redshirt account password | |

To run tests against service deployed in EKS staging cluster, the following steps have to be run:
 - awsrole -u
 - aws-vault exec prod -- ch ecr login
 - kubectl config use-context virginia-1.staging.cloudhealthtech.com
 - awsrole ngstg
 
 If you want to run the tests against production, substitute the following for the last 2 steps above
 - kubectl config use-context virginia-1.prod.cloudhealthtech.com
 - awsrole ngprod
 
For information on setting awsrole, and other eks kubectl info, see [here](https://cloudhealthtech.atlassian.net/wiki/spaces/EN/pages/1867710683/Using+Kubectl+with+EKS+clusters+in+Staging+and+Production)

To run these tests locally, cd to the apitest directory.
To run the tests against the service deployed to the dev/staging/prod cluster, specify the env and namespace as such:

```
TEST_ENV=staging EKS_ENV=virginia-1 NAMESPACE=<optional> API_KEY=<api_key> REDSHIRT_PW=<account_password> rspec

```
the api key and password for redshirt is available from the Quality team

to only run one spec file

```
TEST_ENV=staging EKS_ENV=virginia-1 NAMESPACE=<optional> API_KEY=<api_key> REDSHIRT_PW=<account_password> rspec spec/azure_reservation_recommendations_filter_spec.rb
```

to only run part of one spec - append a ':123' where 123 is the line number in the describe or it block

to have a failing test perform and output the response using curl, change the appropriate header to dbg_header or set the environment variable ```FORCE_CURL_DEBUG=true```

To run against Production or staging, just pass in 'prod' or 'staging' as the TEST_ENV. The NAMESPACE value can be anything when running against a non dev env. 
So if you want to run all the api tests in production following a deploy, run the following steps:
```
TEST_ENV=prod EKS_ENV=virginia-1 NAMESPACE=<optional> API_KEY=<api_key> REDSHIRT_PW=<account_password> rspec
```

to only run part of one spec - append a ':123' where 123 is the line number in the describe or it block

to have a failing test perform and output the response using curl, change the appropriate header to dbg_header or set the environment variable ```FORCE_CURL_DEBUG=true```
