require 'spec_helper'

module ReservationRecommendationsTest
  describe 'ReservationRecommendations generateRecommendationsStatus' do
    include_context 'request metadata'

    it 'Verify generateRecommendationsStatus returns valid response' do
      if TEST_DATA_ENV == 'preprod'
        billing_account = "crn:#{customerId}:aws-account/#{REDSHIRT_PREPROD[:owner_id]}"
      else
        billing_account = "crn:#{customerId}:aws-account/#{REDSHIRT[:owner_id]}"
      end
      supported_status = ['RUNNING', 'COMPLETED', 'FAILED']
      wrap_request do
        variables = {
          billingAccount: billing_account
        }
        graphql url(service: service),
          format_request(
            :generateRecommendationsStatus,
            service: service
          ),
          variables, headers
        expect_success_graphql
      end
      if json_body[:data][:generateRecommendationsStatus] == nil
        # we only want to kick off one refreshReservationRecommendationSource per build
        # so we only run it if generateRecommendationsStatus is null
        # We cannot verify job gets to COMPLETED stage on PR branch, so we just verify valid status
        wrap_request do
          variables = {
            'billingAccount': billing_account
          }
          graphql url(service: service),
            format_request(
              :refreshReservationRecommendationSource,
              service: service
            ),
            variables, headers
          expect_success_graphql
          check(:refreshReservationRecommendationSource, service: service)
        end

        wrap_request do
          variables = {
            billingAccount: billing_account
          }
          graphql url(service: service),
            format_request(
              :generateRecommendationsStatus,
              service: service
            ),
            variables, headers
          expect_success_graphql
          check(:generateRecommendationsStatus, service: service)
          expect(supported_status).to include(json_body[:data][:generateRecommendationsStatus][:status])
        end
      end
    end
  end
end
